import { EncryptedComponents, PackedEncryptedText } from "./constructs";
export declare function getBinarySignature(): number[];
/**
 * Pack encrypted content components into the final encrypted form
 * @param encryptedComponents The encrypted components payload
 * @returns The final encrypted form
 */
export declare function packEncryptedText(encryptedComponents: EncryptedComponents): PackedEncryptedText;
/**
 * Unpack encrypted content components from an encrypted string
 * @param encryptedContent The encrypted string
 * @returns The extracted components
 * @throws {Error} Throws if the number of components is incorrect
 */
export declare function unpackEncryptedText(encryptedContent: PackedEncryptedText): EncryptedComponents;
